commit a8b0c6b4ee8c579b2a76bceb742ad486b6d08747
Author: freddy77 <freddy77>
Date:   Fri Feb 29 10:54:53 2008 +0000

    ported tests and SQL_ROWSET_SIZE fix

diff --git a/ChangeLog b/ChangeLog
index da12d08..e91b2b1 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Fri Feb 29 11:50:06 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/.cvsignore:
+	* src/odbc/unittests/Makefile.am src/odbc/unittests/rowset.c(added):
+	- ported tests and SQL_ROWSET_SIZE fix
+
 Thu Feb 28 18:24:31 EST 2008	JK Lowden <jklowden@freetds.org>
 	* doc/htdoc/news.html announced 0.82RC2
 	* vms/configure.com turn off iconv by default
@@ -180,4 +185,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2493 2008/02/28 23:27:10 jklowden Exp $
+$Id: ChangeLog,v 1.2494 2008/02/29 10:54:53 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 9438336..51a0658 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.472 2008/02/15 11:06:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.473 2008/02/29 10:54:53 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -1472,8 +1472,7 @@ _SQLAllocStmt(SQLHDBC hdbc, SQLHSTMT FAR * phstmt)
 	stmt->attr.simulate_cursor = SQL_SC_NON_UNIQUE;
 	stmt->attr.use_bookmarks = SQL_UB_OFF;
 
-	/* is not the same of using APD sql_desc_bind_type */
-	stmt->sql_rowset_size = SQL_BIND_BY_COLUMN;
+	stmt->sql_rowset_size = 1;
 
 	stmt->row_count = TDS_NO_COUNT;
 	stmt->row_status = NOT_IN_ROW;
@@ -6189,6 +6188,10 @@ _SQLSetStmtAttr(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLIN
 		stmt->attr.use_bookmarks = ui;
 		break;
 	case SQL_ROWSET_SIZE:	/* although this is ODBC2 we must support this attribute */
+		if (((TDS_INTPTR) ValuePtr) < 1) {
+			odbc_errs_add(&stmt->errs, "HY024", NULL);
+			ODBC_RETURN(stmt, SQL_ERROR);
+		}
 		stmt->sql_rowset_size = ui;
 		break;
 	default:
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index fb6855d..4d90945 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -64,6 +64,7 @@ cursor5
 attributes
 hidden
 blob1
+rowset
 cancel
 test64
 wchar
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index f9e14f9..f6bb215 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.72 2008/02/08 09:28:03 freddy77 Exp $
+# $Id: Makefile.am,v 1.73 2008/02/29 10:54:53 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -21,7 +21,7 @@ TESTS		=	\
 			connect2$(EXEEXT) timeout4$(EXEEXT) freeclose$(EXEEXT) \
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
-			cancel$(EXEEXT) wchar$(EXEEXT)
+			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -80,6 +80,7 @@ cursor5_SOURCES	= cursor5.c common.c common.h
 attributes_SOURCES	= attributes.c common.c common.h
 hidden_SOURCES	= hidden.c common.c common.h
 blob1_SOURCES	= blob1.c common.c common.h
+rowset_SOURCES	= rowset.c common.c common.h
 cancel_SOURCES = cancel.c common.c common.h
 wchar_SOURCES = wchar.c common.c common.h
 
diff --git a/src/odbc/unittests/rowset.c b/src/odbc/unittests/rowset.c
new file mode 100644
index 0000000..93a0b2f
--- /dev/null
+++ b/src/odbc/unittests/rowset.c
@@ -0,0 +1,108 @@
+#include "common.h"
+
+static char software_version[] = "$Id: rowset.c,v 1.2 2008/02/29 10:54:53 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static char odbc_err[256];
+static char odbc_sqlstate[6];
+
+static void
+ReadError(void)
+{
+	memset(odbc_err, 0, sizeof(odbc_err));
+	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
+	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL))) {
+		printf("SQLGetDiagRec should not fail\n");
+		exit(1);
+	}
+	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
+}
+
+static void
+test_err(int n)
+{
+	SQLRETURN rc;
+
+	rc = SQLSetStmtAttr(Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(n), 0);
+	if (rc != SQL_ERROR) {
+		fprintf(stderr, "SQLSetStmtAttr should fail\n");
+		Disconnect();
+		exit(1);
+        }
+	ReadError();
+	if (strcmp(odbc_sqlstate, "HY024") != 0) {
+		fprintf(stderr, "Unexpected sql state returned\n");
+		Disconnect();
+		exit(1);
+        }
+}
+
+int
+main(int argc, char *argv[])
+{
+	int i;
+	SQLLEN len;
+#ifdef HAVE_SQLROWSETSIZE
+	SQLROWSETSIZE row_count;
+#else
+	SQLULEN row_count;
+#endif
+	SQLUSMALLINT statuses[10];
+	char buf[32];
+	SQLRETURN rc;
+
+	use_odbc_version3 = 1;
+	Connect();
+
+	/* initial value should be 1 */
+	CHK(SQLGetStmtAttr, (Statement, SQL_ROWSET_SIZE, &len, sizeof(len), NULL));
+	if (len != 1) {
+		fprintf(stderr, "len should be 1\n");
+		Disconnect();
+		return 1;
+	}
+
+	/* check invalid parameter values */
+	test_err(-123);
+	test_err(-1);
+	test_err(0);
+
+	/* set some correct values */
+	CHK(SQLSetStmtAttr, (Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(2), 0));
+	CHK(SQLSetStmtAttr, (Statement, SQL_ROWSET_SIZE, (SQLPOINTER) int2ptr(1), 0));
+
+	/* now check that SQLExtendedFetch works as expected */
+	Command(Statement, "CREATE TABLE #rowset(n INTEGER, c VARCHAR(20))");
+	for (i = 0; i < 10; ++i) {
+		char s[10];
+		char sql[128];
+
+		memset(s, 'a' + i, 9);
+		s[9] = 0;
+		sprintf(sql, "INSERT INTO #rowset(n,c) VALUES(%d,'%s')", i+1, s);
+		Command(Statement, sql);
+	}
+
+	ResetStatement();
+	CHK(SQLSetStmtOption, (Statement, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_DYNAMIC));
+	rc = CommandWithResult(Statement, "SELECT * FROM #rowset ORDER BY n");
+	if (!SQL_SUCCEEDED(rc))
+		ODBC_REPORT_ERROR("SQLExecDirect error");
+
+	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, buf, sizeof(buf), &len));
+
+	row_count = 0xdeadbeef;
+	memset(statuses, 0x55, sizeof(statuses));
+	CHK(SQLExtendedFetch, (Statement, SQL_FETCH_NEXT, 1, &row_count, statuses));
+
+	if (row_count != 1 || statuses[0] != SQL_ROW_SUCCESS || strcmp(buf, "aaaaaaaaa") != 0) {
+		fprintf(stderr, "Invalid result\n");
+		Disconnect();
+		return 1;
+	}
+
+	Disconnect();
+
+	printf("Done.\n");
+	return 0;
+}

